# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudAccountVmcRegionEnumerationSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'api_key': 'str',
        'sddc_id': 'str',
        'username': 'str',
        'password': 'str',
        'host_name': 'str',
        'nsx_host_name': 'str',
        'dc_id': 'str',
        'cloud_account_id': 'str',
        'accept_self_signed_certificate': 'bool',
        'csp_host_name': 'str',
        'certificate_info': 'IaasapiintegrationsCertificateInfo',
        'environment': 'str'
    }

    attribute_map = {
        'api_key': 'apiKey',
        'sddc_id': 'sddcId',
        'username': 'username',
        'password': 'password',
        'host_name': 'hostName',
        'nsx_host_name': 'nsxHostName',
        'dc_id': 'dcId',
        'cloud_account_id': 'cloudAccountId',
        'accept_self_signed_certificate': 'acceptSelfSignedCertificate',
        'csp_host_name': 'cspHostName',
        'certificate_info': 'certificateInfo',
        'environment': 'environment'
    }

    def __init__(self, api_key=None, sddc_id=None, username=None, password=None, host_name=None, nsx_host_name=None, dc_id=None, cloud_account_id=None, accept_self_signed_certificate=None, csp_host_name=None, certificate_info=None, environment=None):  # noqa: E501
        """CloudAccountVmcRegionEnumerationSpecification - a model defined in Swagger"""  # noqa: E501
        self._api_key = None
        self._sddc_id = None
        self._username = None
        self._password = None
        self._host_name = None
        self._nsx_host_name = None
        self._dc_id = None
        self._cloud_account_id = None
        self._accept_self_signed_certificate = None
        self._csp_host_name = None
        self._certificate_info = None
        self._environment = None
        self.discriminator = None
        if api_key is not None:
            self.api_key = api_key
        if sddc_id is not None:
            self.sddc_id = sddc_id
        if username is not None:
            self.username = username
        if password is not None:
            self.password = password
        if host_name is not None:
            self.host_name = host_name
        if nsx_host_name is not None:
            self.nsx_host_name = nsx_host_name
        if dc_id is not None:
            self.dc_id = dc_id
        if cloud_account_id is not None:
            self.cloud_account_id = cloud_account_id
        if accept_self_signed_certificate is not None:
            self.accept_self_signed_certificate = accept_self_signed_certificate
        if csp_host_name is not None:
            self.csp_host_name = csp_host_name
        if certificate_info is not None:
            self.certificate_info = certificate_info
        if environment is not None:
            self.environment = environment

    @property
    def api_key(self):
        """Gets the api_key of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        VMC API access key. Either provide apiKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The api_key of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._api_key

    @api_key.setter
    def api_key(self, api_key):
        """Sets the api_key of this CloudAccountVmcRegionEnumerationSpecification.

        VMC API access key. Either provide apiKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :param api_key: The api_key of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._api_key = api_key

    @property
    def sddc_id(self):
        """Gets the sddc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Identifier of the on-premise SDDC to be used by this cloud account. Note that NSX-V SDDCs are not supported. Either provide sddcId or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The sddc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._sddc_id

    @sddc_id.setter
    def sddc_id(self, sddc_id):
        """Sets the sddc_id of this CloudAccountVmcRegionEnumerationSpecification.

        Identifier of the on-premise SDDC to be used by this cloud account. Note that NSX-V SDDCs are not supported. Either provide sddcId or provide a cloudAccountId of an existing account.  # noqa: E501

        :param sddc_id: The sddc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._sddc_id = sddc_id

    @property
    def username(self):
        """Gets the username of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        vCenter user name for the specified SDDC.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials.Either provide username or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The username of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CloudAccountVmcRegionEnumerationSpecification.

        vCenter user name for the specified SDDC.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials.Either provide username or provide a cloudAccountId of an existing account.  # noqa: E501

        :param username: The username of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """Gets the password of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Password for the user used to authenticate with the cloud Account. Either provide password or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The password of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CloudAccountVmcRegionEnumerationSpecification.

        Password for the user used to authenticate with the cloud Account. Either provide password or provide a cloudAccountId of an existing account.  # noqa: E501

        :param password: The password of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def host_name(self):
        """Gets the host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Enter the IP address or FQDN of the vCenter Server in the specified SDDC. The cloud proxy belongs on this vCenter.  Either provide hostName or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this CloudAccountVmcRegionEnumerationSpecification.

        Enter the IP address or FQDN of the vCenter Server in the specified SDDC. The cloud proxy belongs on this vCenter.  Either provide hostName or provide a cloudAccountId of an existing account.  # noqa: E501

        :param host_name: The host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._host_name = host_name

    @property
    def nsx_host_name(self):
        """Gets the nsx_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        The IP address of the NSX Manager server in the specified SDDC / FQDN.Either provide nsxHostName or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The nsx_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._nsx_host_name

    @nsx_host_name.setter
    def nsx_host_name(self, nsx_host_name):
        """Sets the nsx_host_name of this CloudAccountVmcRegionEnumerationSpecification.

        The IP address of the NSX Manager server in the specified SDDC / FQDN.Either provide nsxHostName or provide a cloudAccountId of an existing account.  # noqa: E501

        :param nsx_host_name: The nsx_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._nsx_host_name = nsx_host_name

    @property
    def dc_id(self):
        """Gets the dc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors  # noqa: E501

        :return: The dc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._dc_id

    @dc_id.setter
    def dc_id(self, dc_id):
        """Sets the dc_id of this CloudAccountVmcRegionEnumerationSpecification.

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors  # noqa: E501

        :param dc_id: The dc_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._dc_id = dc_id

    @property
    def cloud_account_id(self):
        """Gets the cloud_account_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Existing cloud account id. Either provide existing cloud account Id, or apiKey, sddcId, username, password, hostName, nsxHostName.  # noqa: E501

        :return: The cloud_account_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_id

    @cloud_account_id.setter
    def cloud_account_id(self, cloud_account_id):
        """Sets the cloud_account_id of this CloudAccountVmcRegionEnumerationSpecification.

        Existing cloud account id. Either provide existing cloud account Id, or apiKey, sddcId, username, password, hostName, nsxHostName.  # noqa: E501

        :param cloud_account_id: The cloud_account_id of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._cloud_account_id = cloud_account_id

    @property
    def accept_self_signed_certificate(self):
        """Gets the accept_self_signed_certificate of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :return: The accept_self_signed_certificate of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._accept_self_signed_certificate

    @accept_self_signed_certificate.setter
    def accept_self_signed_certificate(self, accept_self_signed_certificate):
        """Sets the accept_self_signed_certificate of this CloudAccountVmcRegionEnumerationSpecification.

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :param accept_self_signed_certificate: The accept_self_signed_certificate of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: bool
        """

        self._accept_self_signed_certificate = accept_self_signed_certificate

    @property
    def csp_host_name(self):
        """Gets the csp_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        The host name of the CSP service.  # noqa: E501

        :return: The csp_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._csp_host_name

    @csp_host_name.setter
    def csp_host_name(self, csp_host_name):
        """Sets the csp_host_name of this CloudAccountVmcRegionEnumerationSpecification.

        The host name of the CSP service.  # noqa: E501

        :param csp_host_name: The csp_host_name of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._csp_host_name = csp_host_name

    @property
    def certificate_info(self):
        """Gets the certificate_info of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501


        :return: The certificate_info of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this CloudAccountVmcRegionEnumerationSpecification.


        :param certificate_info: The certificate_info of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    @property
    def environment(self):
        """Gets the environment of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501

        The environment where the agent has been deployed. When the agent has been deployed using the \"Add Ons\" in VMC UI or Api use \"aap\".  # noqa: E501

        :return: The environment of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._environment

    @environment.setter
    def environment(self, environment):
        """Sets the environment of this CloudAccountVmcRegionEnumerationSpecification.

        The environment where the agent has been deployed. When the agent has been deployed using the \"Add Ons\" in VMC UI or Api use \"aap\".  # noqa: E501

        :param environment: The environment of this CloudAccountVmcRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._environment = environment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudAccountVmcRegionEnumerationSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountVmcRegionEnumerationSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
